<?php
class UptimeAgentConfController extends AppController
{   
	var $helpers = array('Html','Xml');
	var $uses=array('Group','Configure', 'Validation','License',
		"Grpshd", "Rltshdmod",'Agentstatus','Hostkey','Host','Rlthstgrp','Poll',
		'Hstactivelog','Timecontrol','Employeeaccount','Employee');
	var $components = array();
	var $layout='system';
		
	function beforeFilter()
	{

	}
	function addhost($name){
		$criteria = array();
		$criteria[] = "Host.poll_id = 0";
		$criteria[] = "Host.host_name = '".$this->Lv->spec_char_dbm($name)."'";
		$criteria[] = "Host.access_name = '".$this->Lv->spec_char_dbm($name)."'";
		$host = $this->Host->find($criteria);
		if(!empty($host)){
			echo $host['Host']['id'];
			exit;
		}
		$regist = date('Y-m-d H:i:s',time());
		$allupdatedate = Array('Host' => Array(
								'host_name' => $this->Lv->spec_char_dbm($name),
								'access_name' => $this->Lv->spec_char_dbm($name),
								'poll_id' => 0,
								'poll_type' => 0,
								'status' => 2,
								'isagent' => 1,
								'regist_time' => $regist)
								);
		
		$this->Host->save($allupdatedate);
		$criteria[] = "Host.regist_time = '".$regist."'";
		$data= $this->Host->find($criteria);
		$addgroupdate=Array(
				'Rlthstgrp' => Array(
				'host_id' => $data['Host']['id'],
				'group_id' => 1,
				)
				);
		$this->Rlthstgrp->save($addgroupdate);
		echo $data['Host']['id'];
		exit;
	}
	
	function getParentschedule($groupid)
	{
		$default = $this->Grpshd->find(array("group_id" => $groupid),
			array('Grpshd.id','Grpshd.group_id',
				'Grpshd.start_date','Grpshd.end_date','Grpshd.start_time','Grpshd.end_time',
				'Grpshd.weekday','Grpshd.onlogon',
				'timediff(end_time,start_time) as Grpshd__time_diff',
				'time_to_sec(timediff(end_time,start_time)) as Grpshd__second_diff'));
		if(empty($default))
		{
			$parent = $this->Group->group_father_id($groupid);
			if(!empty($parent))
				$default = $this->getParentschedule($parent);
		}
		return $default;
	}
	
	function getschedule($group_id)
	{
		require_once( '../csv/xml.php' );
		$xml = new xml(); 
		$xml->setSpace(true); 
		
		$d = &$xml->addDeclare('?xml'); 
        $d->setAttrib("version","1.0");
        $d->setAttrib("encoding","Shift_JIS");
		
		$version = 100;

		$conf = $this->getParentschedule($group_id);
		$xml1 = &$xml->addElement("Schedule"); 
		
		if(!empty($conf)){
			//ライセンスの確認
			$license_endtime=$this->License->findAll(array("1=1"),array("License.end_time"));
			//取得期間が無期限の場合、現在からライセンスの期限までとする 
			if(($conf['Grpshd']['start_date']==$conf['Grpshd']['end_date'])&&($conf['Grpshd']['end_date']=="2038-01-01"))
			{
				$conf['Grpshd']['start_date'] = date("Y-m-d");
				$conf['Grpshd']['end_date'] = substr($license_endtime[0]['License']['end_time'],0,10);
			}
			
			$xml2 = $xml1->addElement("Item", ""); 

			$names = array('id', 'group_id',
				'start_date','end_date','start_time','end_time',
				'weekday','onlogon','time_diff','second_diff');
			foreach($conf['Grpshd'] as $key=>$value)
			{
				if(in_array($key, $names))
					$xml2->setAttrib($key, $value); 
			}
			$sch_id = $conf['Grpshd']['id'];
			$agent = $this->Rltshdmod->find(array("Rltshdmod.sch_id" => $sch_id, "Rltshdmod.module_id" => 18));

			if(isset($agent['Rltshdmod']['inter_time']))
				$xml2->setAttrib("agenttime", $agent['Rltshdmod']['inter_time']); 
			else
				$xml2->setAttrib("agenttime", SCHEDULE_AGENT); 
		}
		$rec = $xml->toString();
		
		echo $rec;exit;
	}
	//UUIDからhostid
	function gethostid($keystr)
    {
		$criteria[] = "Hostkey.keystr = '".$keystr."'";
		$host = $this->Hostkey->find($criteria);
		if(empty($host)){
			echo "0";
			exit;
		}
		
		echo $host['Hostkey']['host_id'];
		exit;
    }
	
	//グループの基本設定を取得　無い場合は親の設定を取得
	function getTimecontrol($groupid)
	{
		$default = $this->Timecontrol->find(array("group_id" => $groupid));
		if(empty($default))
		{
			$parent = $this->Group->group_father_id($groupid);
			if(!empty($parent))
				$default = $this->getTimecontrol($parent);
		}
		return $default;
	}
	
	function upload(){
		$tslog = $_POST['tslog'];
		$interval = $_POST['interval'];
		$hostid = $_POST['hostid'];
		$newlog = array(
			'Hstactivelog' => array(
					'host_id' => $hostid,
					'tslog' => $tslog,
					'collect_flag' => 1,
					'lasttime' => $tslog)
			); 	
		/*$employeeacc = $this->Employeeaccount->find(
			"Employeeaccount.host_id = {$hostid}",
			"Employeeaccount.employee_id");
		if(!isset($employeeacc['Employeeaccount']['employee_id'])){
			echo "-1";
			exit;
		}
		$empid = $employeeacc['Employeeaccount']['employee_id'];
		*/	
		$last = $this->Hstactivelog->find(
			"Hstactivelog.host_id = {$hostid} and Hstactivelog.tslog < '{$tslog}'",
			"max(Hstactivelog.tslog) as Hstactivelog__maxtime");
//var_dump($last);
		if(isset($last['Hstactivelog']['maxtime'])){
			$maxtime = $last['Hstactivelog']['maxtime'];
			$last = $this->Hstactivelog->find(array("Hstactivelog.host_id" => $hostid, "Hstactivelog.tslog" => $maxtime, "Hstactivelog.log_status" => 1));
			$last2 = $this->Hstactivelog->find(array("Hstactivelog.host_id" => $hostid, "Hstactivelog.tslog" => $maxtime, "Hstactivelog.log_status" => 2));
			
				//var_dump($last2);
			if(!isset($last) && isset($last2)){//前回はログオフ
				$newlog['Hstactivelog']['log_status'] = 1; 		
				$this->Hstactivelog->save($newlog);	
				echo "5";
			}else if(isset($last)){
				$lasttime = $last['Hstactivelog']['lasttime'];
				$diff = strtotime($tslog) - (strtotime($lasttime) + $interval + 30);
				if($diff > 0){//（取得間隔＋30秒）以上
					$newlog['Hstactivelog']['log_status'] = 1; 							
					$this->Hstactivelog->save($newlog);		
					
					$newlog['Hstactivelog']['log_status'] = 2; 	
					$newlog['Hstactivelog']['tslog'] = date('Y-m-d H:i:s', strtotime($lasttime) + $interval);
					$newlog['Hstactivelog']['lasttime'] = $newlog['Hstactivelog']['tslog'];
					$this->Hstactivelog->save($newlog);	
					echo "4";
				}else{//（取得間隔＋30秒）未満の時間差
				
					$grp = $this->Rlthstgrp->findByHostId($hostid);
					if(!isset($grp)){
						echo "-1";
						exit;
					}else
						$groupid = $grp['Rlthstgrp']['group_id'];
					$default = $this->getTimecontrol($groupid);
					if(!isset($default))
					{
						echo -2;
						exit;
					}
					$start_day = $default['Timecontrol']['start_day'];
					$last = date('H:i', strtotime($lasttime));
					
					//echo $last."\n";
					//echo $start_day."\n";
					
					if($last < $start_day){
						$start = date('Y-m-d', strtotime($lasttime))." ".$start_day.":00";
					}else
						$start = date('Y-m-d', strtotime($tslog))." ".$start_day.":00";
					
					//echo $start."\n";
					//echo $lasttime ."<". $start."\n" ;
					//echo $start ."<". $tslog."\n";
					if($lasttime < $start && $start <= $tslog){//日付変更時刻より前
						//$newlog['Hstactivelog']['tslog'] = $start;
						$newlog['Hstactivelog']['tslog'] = $start;
						$newlog['Hstactivelog']['lasttime'] = $lasttime;//集計のため前日
						//$newlog['Hstactivelog']['lasttime'] = $newlog['Hstactivelog']['tslog'];
						$newlog['Hstactivelog']['log_status'] = 2; 							
						$this->Hstactivelog->save($newlog);		
						
						$newlog['Hstactivelog']['log_status'] = 1; 	
						$newlog['Hstactivelog']['tslog'] = $start;
						$newlog['Hstactivelog']['lasttime'] = $tslog;					
						$this->Hstactivelog->save($newlog);		
						echo "6";
					}else{//更新
						$crit = array();
						$crit[] = "Hstactivelog.host_id = ".$hostid;
						$crit[] = "Hstactivelog.tslog = '".$maxtime."'";
						$crit[] = "Hstactivelog.log_status = 1";
						$this->Hstactivelog->updateAll($crit, array('Hstactivelog.lasttime' => "'".$tslog."'"));	
						echo "3";
					}
					
				}
			
			}
		}else{//initial
			$newlog['Hstactivelog']['log_status'] = 1; 		
			$this->Hstactivelog->save($newlog);	
			echo "2";
		}
				
	
		
		echo "1";
		exit;
	}
	
//アップデータからDB上のPSバージョン情報を更新
    function updater($hostid, $version)
    {
		//$this->layout='ajax';
		if(is_numeric($hostid) || $hostid > 0){
			$agent = array(
			'Agentstatus' => array(
					'host_id' => $hostid,
					'update_status' => 0,
					'update_time' => date("Y/m/d H:i:s"),
					'version' => $version,
				)
			); 							
			$this->Agentstatus->save($agent);			
			
			echo "ok";
			exit;
		}
		echo "0";
		exit;
    }
	
	//SPOOLにアップ
	function uplog($psid = 0)
	{
		//$this->layout='ajax';
		set_time_limit(0);

		if(!is_numeric($psid)){
			echo "0";
			exit;
		}
		
		$criteria[] = "Poll.id = ".$psid;
		$poll = $this->Poll->find($criteria);
		if(empty($poll)){
			echo "0";
			exit;
		}
			
		//		debug($_FILES, true);
		//アップロードされたファイルのパス
		$filename = $_FILES['impfile']['tmp_name'];
		if(!empty($filename)){
			//一時フォルダから移動
			//$tmp = str_replace("\\","/", TMP);// lv/app/tmp/
			$tmp =str_replace("\\","/", SPOOL_PATH);
			//$uploadfile = $dir . basename($filename);
			$logdir = $tmp . "/agent";
			if(!file_exists($logdir)){
				mkdir($logdir);
			}
			$logdir = $tmp . "/agent/data";
			if(!file_exists($logdir)){
				mkdir($logdir);
			}
			$name = basename($_FILES['impfile']['name']);
			$uploadfile = $logdir. "/" . $name;
			move_uploaded_file($filename, $uploadfile);
			
			echo "1";
		}
		exit;
	}
	
	//更新のログ
	function updatelog($hostid = 0)
	{
		//$this->layout='ajax';
		set_time_limit(0);

		if($hostid == 0 || !is_numeric($hostid))
			exit;
		
		$criteria[] = "Host.id = ".$hostid;
		$host = $this->Host->find($criteria);
		if(empty($host))
			exit;
			
		//		debug($_FILES, true);
		//アップロードされたファイルのパス
		$filename = $_FILES['impfile']['tmp_name'];
		if(!empty($filename)){
			//一時フォルダから移動
			//$tmp = str_replace("\\","/", TMP);// lv/app/tmp/
			$tmp =str_replace("\\","/", RESTORE_FILE_PATH);
			//$uploadfile = $dir . basename($filename);
			$logdir = $tmp . "/../Agentlogs";
			if(!file_exists($logdir)){
				mkdir($logdir);
			}
			$uploadfile = $logdir. "/" . $hostid ."_".date("YmdHis"). ".txt";
			move_uploaded_file($filename, $uploadfile);
			
			//$my_file = file_get_contents($uploadfile, false, NULL, 0, 60000);
			//unlink($uploadfile);
			
			echo "1";
			//echo $filename."&&&".$uploadfile;
		}
		exit;
	}
}
?>